%******************************************************************
% Script for calculations with the Homogeneous transformation matrices
%******************************************************************
%
%**************************
% Author: Rotem Sharoni
% Last updated 1st of April 2016
%**************************

%% Symbolic calculations:
syms d1 c0 c1 s0 s1 l0 l1 c01 s01
%c1 = cos(theta_0), sg = sin(gamma), stg = sin(theta + gamma)
%Calculate the transformation matrices for each step:
T1 = denhartmat_final(180,1,0,-90);
%"Convert" T1 to symbolic matrix:
T1 = [-1     0     0     0
     0     0    -1     0
     0    -1     0     d1
     0     0     0     1];
 T2 = [c0 -s0*cosd(0) s0*sind(0) l0*c0;
        s0 c0*cosd(0) -c0*sind(0) l0*s0;
        0 sind(0) cosd(0) 0;
        0 0 0 1];
 T3 = [c1 -s1*cosd(0) s1*sind(0) l1*c1;
        s1 c1*cosd(0) -c1*sind(0) l1*s1;
        0 sind(0) cosd(0) 0;
        0 0 0 1];
%Transformation matrix from pendulum tip to base frame (not NED):    
T_30 = T1*T2*T3;
T_30_simple = [-c01 s01 0 -l1*c01-l0*c0;
                0 0 -1 0;
                -s01 -c01 0 d1-l0*s0-l1*s01;
                0 0 0 1]
%Then transforming it to NED:
% T_rn = [Rzyx(deg2rad(180),deg2rad(-90),0) zeros(3,1);zeros(1,3) 1]
T_rn = [0 0 1 0;0 1 0 0;1 0 0 0;0 0 0 1]
T30n = T_rn*T_30_simple
%% Numeric calculations:

%Denavit-Hartenberg table for the MIP (degrees and meters), 
%joint variables are set to zero:
table = [180 0 0 -90;
        0 .3 0 0;
        0 1.5 0 0];
joints = [0 1 1]; % 0 is prismatic and 1 is rotational joint
% Value for each joint variable (columns), for each time step (rows)
values = [1 0 0;
        1 5 0;
        1 5 5;
        1 5 10];
time = 2; %Time between each timestep in values

%Plot the "Robot" for each pose given by values:
DHM_final = DirectKinematics(table, joints, values, time);