function Rx = rotx(alpha)
%**************************************************************************
% This function returns the rotation matrix for a rotation of alpha degrees
% about the x axis.
%
% Input: 
%   alpha: angle in degrees
% Output:
%   Rx: Rotation matrix
%
%****************************
% Author: Rotem Sharoni
% Last updated: 1st of April 2016
% ***************************

Rx = [1 0 0;
    0 cosd(alpha) -sind(alpha);
    0 sind(alpha) cosd(alpha)];
end