function Ry = roty(beta)
%**************************************************************************
% This function returns the rotation matrix for a rotation of beta degrees
% about the y axis.
%
% Input: 
%   beta: angle in degrees
% Output:
%   Ry: Rotation matrix
%
%****************************
% Author: Rotem Sharoni
% Last updated: 1st of April 2016
% ***************************

Ry = [cosd(beta) 0 sind(beta);
    0 1 0;
    -sind(beta) 0 cosd(beta)];
end