function Rz = rotz(gamma)
%**************************************************************************
% This function returns the rotation matrix for a rotation of gamma degrees
% about the z axis.
%
% Input: 
%   gamma: angle in degrees
% Output:
%   Rz: Rotation matrix
%
%****************************
% Author: Rotem Sharoni
% Last updated: 1st of April 2016
% ***************************

Rz = [cosd(gamma) -sind(gamma) 0;
    sind(gamma) cosd(gamma) 0;
    0 0 1];
end