% ********************************************************************
% This script initializes parameters and runs the MIP model with surge and
% pitch coupling.
% ********************************************************************
%
% ***********************************
% Author: Rotem Sharoni
% Last updated: 3rd of April 2016
% ***********************************
%

x_init = [0 deg2rad(0) deg2rad(10)]'; %Initial "pose" of the MIP

tsim = 2; %Simulation time, s
sim MIPv2

%Plot the results:
set(groot, 'defaultAxesTickLabelInterpreter','latex'); 
set(groot, 'defaultLegendInterpreter','latex');

figure
subplot(3,1,1)
plot(x.time,x.data(:,1))
hold on 
plot(x_d.time,x_d.data(:,1));
legend('$x$','$\dot{x}$')
xlabel('Time (s)')
title('Position')
subplot(3,1,2)
plot(x.time,rad2deg(x.data(:,2)))
hold on 
plot(x_d.time,rad2deg(x_d.data(:,2)));
legend('$\theta_0$','$\dot{\theta}_0$')
xlabel('Time (s)')
title('Pitch [deg]')
subplot(3,1,3)
plot(x.time,rad2deg(x.data(:,3)))
hold on 
plot(x_d.time,rad2deg(x_d.data(:,2)));
legend('$\theta_1$','$\dot{\theta}_1$')
xlabel('Time (s)')
title('Pendulum angle [deg]')
